// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2020 Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


using System;
using Gtk;

namespace Hiperscan.GtkExtensions.Widgets
{
    public class Font
    {
        public static void SetFont(Gtk.Widget widget, string font_name)
        {
            Pango.FontDescription fd = null;

            Gtk.Label label = widget as Gtk.Label;
            if (label != null)
            {
                fd = label.Style.FontDesc.Copy();
                fd.Family = font_name;
                label.ModifyFont(fd);
            }

            Gtk.Entry entry = widget as Gtk.Entry;
            if (entry != null)
            {
                fd = entry.Style.FontDesc.Copy();
                fd.Family = font_name;
                entry.ModifyFont(fd);
            }

            Gtk.ComboBox combobox = widget as Gtk.ComboBox;
            if (combobox != null)
            {
                foreach (CellRenderer cell in combobox.Cells)
                {
                    CellRendererText ct = cell as CellRendererText;
                    if (ct != null)
                        ct.Family = font_name;

                }
            }

            FlexLabel Flex_label = widget as FlexLabel;
            if (Flex_label != null)
            {
                Flex_label.FontName = font_name;
            }

            Gtk.Container container = widget as Gtk.Container;
            if (container != null)
            {
                foreach (Widget child in container.Children)
                    Font.SetFont(child, font_name);
            }
        }
    }
}
